classification
Title: Cannot copy the same directory structure to the same destination more than once
Type: crash Stage: resolved
Components: Distutils Versions: Python 3.4
process
Status: closed Resolution: wont fix
Dependencies: Superseder:
Assigned To: Nosy List: Csaba.Makara, dstufft, eric.araujo
Priority: normal Keywords:

Created on 2014-08-04 07:15 by Csaba.Makara, last changed 2014-08-07 13:05 by eric.araujo. This issue is now closed.

Files
File name Uploaded Description Edit
example.py Csaba.Makara, 2014-08-04 07:15 Example script of the problem
Messages (4)
msg224691 - (view) Author: Csaba Makara (Csaba.Makara) Date: 2014-08-04 07:15
If I use the distutils.dir_util.copy_tree to copy the same directory structure multiple times to the same place (even from multiple sources) but I remove and recreate the target_directory before each copy, the following exception accurs:

g:\_Programming>py example.py
Traceback (most recent call last):
  File "E:\Python34\lib\distutils\file_util.py", line 41, in _copy_file_contents

    fdst = open(dst, 'wb')
FileNotFoundError: [Errno 2] No such file or directory: 'c:\\bin\\folder_inside\
\file_inside.txt'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "example.py", line 13, in <module>
    dir_util.copy_tree(source_folder2, target_folder)
  File "E:\Python34\lib\distutils\dir_util.py", line 160, in copy_tree
    verbose=verbose, dry_run=dry_run))
  File "E:\Python34\lib\distutils\dir_util.py", line 164, in copy_tree
    dry_run=dry_run)
  File "E:\Python34\lib\distutils\file_util.py", line 143, in copy_file
    _copy_file_contents(src, dst)
  File "E:\Python34\lib\distutils\file_util.py", line 44, in _copy_file_contents

    "could not create '%s': %s" % (dst, e.strerror))
distutils.errors.DistutilsFileError: could not create 'c:\bin\folder_inside\file
_inside.txt': No such file or directory
_______________________________________________________________

If the target_folder is not deleted, the problem won't appear. 
The problem seems to be the handling of the inner directories. In the second attempt the inner folders are thought to be existing, but they are not.

See the attached script.
msg224749 - (view) Author: Éric Araujo (eric.araujo) * (Python committer) Date: 2014-08-04 18:23
Thanks for the report.  Did you find this issue with a setup.py file or with direct usage of dir_utils.copy_tree?  These distutils modules are not meant for general use, so bugs that don’t occur during regular use of setup.py files will probably not get fixed.  (Distutils has fragile internals so it’s policy to do as little change as possible to avoid breaking other things.)
msg224995 - (view) Author: Csaba Makara (Csaba.Makara) Date: 2014-08-07 06:45
Sorry for the late answer.
It was a direct usage of the dir_utils.copy_tree.
I absolutely understand you don't want to touch it.
msg225010 - (view) Author: Éric Araujo (eric.araujo) * (Python committer) Date: 2014-08-07 13:05
Thanks.  There is a function intended for general use: shutil.copytree; it may have the same behavior (not a bug if it's documented).
History
Date User Action Args
2014-08-07 13:05:41eric.araujosetstatus: open -> closed
resolution: wont fix
messages: + msg225010

stage: resolved
2014-08-07 06:45:41Csaba.Makarasetmessages: + msg224995
2014-08-04 18:23:04eric.araujosetmessages: + msg224749
2014-08-04 07:15:34Csaba.Makaracreate